﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FiguryPolimorfizmMetodWirtualnych
{
    internal class ObiektPlaski
    {
        private int n;//ilość odcinków
        private List<float> odcinek;
        private String nazwa = "";

        //metoda przypisuje i zwraca
        //nazwę tworzonego obiektu
        public String Nazwa { 
              set { nazwa = value; } 
              get { return nazwa; } 
        }  
        public int IleOdcinkow
        {
            set{n = value;//ustaw ile odcinkow ma obiekt plaski
                odcinek.Clear();//czysc liste odcinkow
                //ustaw dlugosci odcinkow na zero
                for (int i = 0; i < n; i++) odcinek.Add(0);
            }
            get { return n; }//zwróć ilość odcinków
        }

        public List<float> Odcinek { 
            //metoda zwraca liste odcinków
            //tworzacych obiekt plaski
            get { return odcinek; } 
        }

        //konstruktor
        public ObiektPlaski(int ileOdcinkow) 
        { 
            odcinek=new List<float>();
            IleOdcinkow = ileOdcinkow;
        }
        //destruktor
        ~ObiektPlaski()
        {
            odcinek.Clear();
            odcinek = null;
        }
        //definicja nagłówków wirtualnych metod przeznaczonych
        //do nadpisania w klasach dziedziczących
        virtual public float Obwod() { return 0; }
        virtual public float Pole() { return 0; }
        virtual public float Przekatna() { return 0; }
        virtual public float Srednica() { return 0; }
        virtual public void Promien(float R) { }
    }
}
